
USE AdventureWorks
GO

exec sp_configure 'sho',1
reconfigure
go
exec sp_configure 'clr',1
reconfigure
go

-- Catalog the assembly
CREATE ASSEMBLY HierarchyId_Operations 
FROM 'c:\temp\HierarchyId_Operations.dll'
GO

CREATE FUNCTION dbo.ListAncestors (@node hierarchyid)
RETURNS TABLE (node hierarchyid)
AS
EXTERNAL NAME HierarchyId_Operations.HierarchyId_Operations.ListAncestors
GO

DECLARE @h hierarchyid
SELECT @h = OrgNode 
FROM HumanResources.NewOrg  
WHERE LoginID = 'adventure-works\janice0' -- /1/1/5/2/

SELECT LoginID, OrgNode.ToString() AS LogicalNode
FROM HumanResources.NewOrg AS ED
JOIN dbo.ListAncestors(@h) AS A 
   ON ED.OrgNode = A.Node
GO

CREATE FUNCTION CommonAncestor (@node1 hierarchyid, @node2 hierarchyid)
RETURNS hierarchyid
AS
EXTERNAL NAME HierarchyId_Operations.HierarchyId_Operations.CommonAncestor
GO

DECLARE @h1 hierarchyid, @h2 hierarchyid

SELECT @h1 = OrgNode 
FROM  HumanResources.NewOrg 
WHERE LoginID = 'adventure-works\jossef0' -- Node is /1/1/3/

SELECT @h2 = OrgNode 
FROM HumanResources.NewOrg  
WHERE LoginID = 'adventure-works\janice0' -- Node is /1/1/5/2/

SELECT OrgNode.ToString() AS LogicalNode, LoginID 
FROM HumanResources.NewOrg  
WHERE OrgNode = dbo.CommonAncestor(@h1, @h2) ;
GO

DROP FUNCTION CommonAncestor
DROP FUNCTION ListAncestors
DROP ASSEMBLY HierarchyId_Operations
