
USE AdventureWorks
GO

-- All Managers, use IsDescendantOf

DECLARE @CurrentEmployee hierarchyid

SELECT @CurrentEmployee = OrgNode
FROM HumanResources.EmployeeOrg
WHERE EmployeeID = 46 ;

SELECT *
FROM HumanResources.EmployeeOrg
WHERE @CurrentEmployee.IsDescendantOf(OrgNode) = 1 ;
GO

-- direct subordinates of employee 46
DECLARE @CurrentEmployee hierarchyid

SELECT @CurrentEmployee = OrgNode
FROM HumanResources.EmployeeOrg
WHERE EmployeeID = 46 ;

SELECT OrgNode.ToString() AS Text_OrgNode, *
FROM HumanResources.EmployeeOrg
WHERE OrgNode.GetAncestor(1) = @CurrentEmployee
GO

-- Level 2 Subordinates of employee 6
DECLARE @CurrentEmployee hierarchyid

SELECT @CurrentEmployee = OrgNode
FROM HumanResources.EmployeeOrg
WHERE EmployeeID = 6 ;

SELECT OrgNode.ToString() AS Text_OrgNode, *
FROM HumanResources.EmployeeOrg
WHERE OrgNode.GetAncestor(2) = @CurrentEmployee

-- Use GetLevel
SELECT OrgNode.ToString() AS Text_OrgNode, 
OrgNode.GetLevel() AS EmpLevel, *
FROM HumanResources.EmployeeOrg ;
GO

-- Use GetRoot
SELECT OrgNode.ToString() AS Text_OrgNode, *
FROM HumanResources.EmployeeOrg
WHERE OrgNode = hierarchyid::GetRoot() ;
GO

