
use tempdb
go

-- The hierarchyid does not guarantee or enforce
-- the shape of the hierarchy

-- create a table with no constraint on hid
CREATE TABLE t (id int identity, hid hierarchyid)
go

-- don't need to start at the root
insert t values('/3/4/')
select id, hid.ToString() as hid from t
go

-- can insert duplicate values
insert t values('/3/4/')
select id, hid.ToString() as hid from t
go

-- get descendant
declare @a hierarchyid = ( select hid from t where id = 1 )
insert t values(@a.GetDescendant(NULL, NULL))
select id, hid.ToString() as hid from t
go

declare @a hierarchyid = ( select hid from t where id = 1 )
declare @b hierarchyid = ( select hid from t where hid = '/3/4/1/' )
-- following-sibling of @b
insert t values(@a.GetDescendant(@b, NULL))
select id, hid.ToString() as hid from t
go

declare @a hierarchyid = ( select hid from t where id = 1 )
declare @b hierarchyid = ( select hid from t where hid = '/3/4/1/' )
-- preceding-sibling of @b
insert t values(@a.GetDescendant(NULL, @b))
select id, hid.ToString() from t
go

declare @a hierarchyid = ( select hid from t where id = 1 )
declare @b hierarchyid = ( select hid from t where hid = '/3/4/0/' )
-- preceding-sibling of @b
insert t values(@a.GetDescendant(NULL, @b))
select id, hid.ToString() as hid from t
go

declare @a hierarchyid = ( select hid from t where id = 1 )
declare @b hierarchyid = ( select hid from t where hid = '/3/4/1/' )
declare @c hierarchyid = ( select hid from t where hid = '/3/4/2/' )
-- sibling between @b and @c
insert t values(@a.GetDescendant(@b, @c))
select id, hid.ToString() as hid from t
go